--- Totestra-20120615.py	2012-06-15 22:54:54.000000000 -0500
+++ qTotestraHUGE.py	2012-06-15 23:51:36.000000000 -0500
@@ -1,5 +1,5 @@
 ##############################################################################
-## File: Totestra.py version 20120615 (June 15, 2012)
+## File: Totestra.py version 20120612 (June 12, 2012)
 ## Note: This is a finished product.  
 ## Original file: PerfectWorld.py version 2.06
 ## Author: Rich Marinaccio
@@ -51,11 +51,10 @@
 ## Version History
 ## Totestra - Sam Trenholme's update of PerfectWorld2.py
 ##
-## 20120615:
-## 1) One-line bugfix for multi-player maps
-##
 ## 20120612:
-## 1) Bugfix with rocky maps
+## 1) Bugfix with rocky maps; hack to make extra-extra huge maps (up
+##    to 288x192!  Yes, Civ4 is buggy and slow with maps that huge, but, by
+##    golly it can be done)
 ##
 ## 20120603:
 ## 1) The chance of a large continent splitting at the edge of the map
@@ -235,17 +234,17 @@
 import os
 
 # Options
-OPTION_MapSeed = 10
+OPTION_MapSeed = 7
 OPTION_NewWorld = 0
 OPTION_Pangaea = 1
 OPTION_Wrap = 2
-OPTION_IslandFactor = 3
-OPTION_Patience = 4
-OPTION_MapRatio = 5
-OPTION_MapResources = 6
-OPTION_Handicap = 7
-OPTION_NoRotate = 8
-OPTION_SmoothPeaks = 9
+OPTION_MapResources = 3
+OPTION_Handicap = 4
+OPTION_NoRotate = 5
+OPTION_SmoothPeaks = 6
+OPTION_IslandFactor = 8
+OPTION_Patience = 9
+OPTION_MapRatio = 10
 OPTION_MAX = OPTION_MapSeed + 1 # Add 1 because it's 1-indexed
 
 # Setting this to 1 will allow the buggy 1:2 ratio; this ratio has
@@ -668,6 +667,7 @@
         # How long are they willing to wait for the map to be made
         patience = mmap.getCustomMapOption(OPTION_Patience)
         patience += 1 # Patience at 0 is broken
+	patience = 3 # Extra HUGE maps
 
 	# This allows me to have one final usable bit in the service tag
         self.serviceFlags <<= 3
@@ -697,6 +697,7 @@
 
         # X and Y values for the map's aspect ratio
 	ratioValue = mmap.getCustomMapOption(OPTION_MapRatio)
+	ratioValue = 2 # Overwritten for HUGE maps
 	if 1 == 2: # Dummy, does nothing, so we don't get elif problems
 		self.ratioX = 3
 		self.ratioY = 2
@@ -730,6 +731,7 @@
         self.serviceFlags |= (ratioValue & 7) # 3 bits; total 13
 
         selectionID = mmap.getCustomMapOption(OPTION_IslandFactor)
+	selectionID = 0 # HUGE maps
 
         self.serviceFlags <<= 2
         self.serviceFlags |= (selectionID & 3) # Island factor
@@ -738,7 +740,10 @@
 	if(patience < 2):
 		selectionID = 0
 
-        heightmap_size_factor = 3 + selectionID
+        self.hmMaxGrain = 32 
+        heightmap_size_factor = 3 
+	self.ratioX = 3
+	self.ratioY = 2
         self.hmWidth  = (self.hmMaxGrain * self.ratioX * 
                          heightmap_size_factor)
         self.hmHeight = (self.hmMaxGrain * self.ratioY * 
@@ -5703,12 +5708,12 @@
     
 def getGridSize(argsList):
     grid_sizes = {
-		WorldSizeTypes.WORLDSIZE_DUEL:		(11,7),
-		WorldSizeTypes.WORLDSIZE_TINY:		(15,10),
-		WorldSizeTypes.WORLDSIZE_SMALL:		(20,13),
-		WorldSizeTypes.WORLDSIZE_STANDARD:	(24,16),
-		WorldSizeTypes.WORLDSIZE_LARGE:		(30,20),
-		WorldSizeTypes.WORLDSIZE_HUGE:		(36,24)
+		WorldSizeTypes.WORLDSIZE_DUEL:		(22,14),
+		WorldSizeTypes.WORLDSIZE_TINY:		(30,20),
+		WorldSizeTypes.WORLDSIZE_SMALL:		(40,26),
+		WorldSizeTypes.WORLDSIZE_STANDARD:	(48,32),
+		WorldSizeTypes.WORLDSIZE_LARGE:		(60,40),
+		WorldSizeTypes.WORLDSIZE_HUGE:		(72,48)
     }
     if (argsList[0] == -1): # (-1,) is passed to function on loads
             return []
